from machine import Pin, ADC # Importem llibreria i funcions
from time import sleep_ms # Importem llibreria i funcio
from math import log # Importem ln aci log


ntc = ADC(Pin(36)) # Emprarem ADC "analog to digital conversion" al pin 36
ntc.atten(ADC.ATTN_11DB)  # Voltatge max: 3.3v llavors eixida sera 4095

#Definició de coeficients i constants metode de Steinhart–Hart
Ventrada=3.3 # [V] Tensió d'entrada al divisor de tensió
Rauxiliar=10000 #  [ohm] Resistencia secundaria al divisor de tensió.
R0=10000 # [ohm] Valor de NTC nominal a 25ºC
T0=298.15 # [K] (25ºC) Valor en ºK de 25ºC
beta=3891 # [K] Paràmetre B
Rinfinit=0.0214906446 # [ohm] Paràmetre Rinfinit

# Definicio de variables
Veixida=0.0 # [V] Tensió donada pel divisor de tensió
RNTC=0.0 # [ohm] Resistència del NTC
TempK=0.0 # [K] Temperatura d'eixida en Kelvin
TempC=0.0 # [ºC] Temperatura d'eixida en Celsius

for x in range(1, 10000): # Repetim un cicle 10000 vegades
    Lectura_NTC = ntc.read() # llegim ntc.read() i ho guardem en la variable Lectura_NTC
    print(" Lectura_NTC = ")
    print(Lectura_NTC) # Imprimim el valor de la variable
    Veixida=Ventrada*(Lectura_NTC/4095) # Calcul del valor de voltatge del NTC ara
    RNTC=(Rauxiliar*Veixida/(Ventrada-Veixida)) # Calcul RNTC
    TempK=(beta/log(RNTC/Rinfinit))  # Calcul de la temperatura estimada de SteinHart-Hart en Kelvins
    TempC=TempK-273.15 # Càlcul de la temperatura estimada en Centigrads
    print(" T (C)=") # Missatge
    print(TempC) # T en Celsius
    print("  " ) # Liniea en Blanc
    sleep_ms(200) # Parem el temps
    